<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Annexe A. Empaquetage avancé</title>
    <link rel="stylesheet" type="text/css" href="debian.css"/>
    <meta name="generator" content="DocBook XSL Stylesheets V1.78.1"/>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <link rel="home" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="up" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="prev" href="upload.fr.html" title="Chapitre 9. Envoi de paquet"/>
  </head>
  <body>
    <div class="navheader">
      <table width="100%" summary="Navigation header">
        <tr>
          <th colspan="3" align="center">Annexe A. Empaquetage avancé</th>
        </tr>
        <tr>
          <td align="left"><a accesskey="p" href="upload.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <th width="60%" align="center"> </th>
          <td align="right"> </td>
        </tr>
      </table>
      <hr/>
    </div>
    <div class="appendix">
      <div class="titlepage">
        <div>
          <div>
            <h1 class="title"><a id="advanced"/>Annexe A. Empaquetage avancé</h1>
          </div>
        </div>
      </div>
      <div class="toc">
        <p>
          <strong>Table des matières</strong>
        </p>
        <dl class="toc">
          <dt>
            <span class="section">
              <a href="advanced.fr.html#library">A.1. Bibliothèques partagées</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="advanced.fr.html#librarysymbols">A.2. Gestion de
<code class="filename">debian/<em class="replaceable"><code>paquet</code></em>.symbols</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="advanced.fr.html#multiarch">A.3. Multiarchitecture</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="advanced.fr.html#librarypackage">A.4. Construction d'un paquet de bibliothèque partagée</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="advanced.fr.html#native-dh-make">A.5. Paquet Debian natif</a>
            </span>
          </dt>
        </dl>
      </div>
      <p>
Voici quelques conseils et pointeurs pour des sujets d'empaquetage avancé
auxquels vous serez sans doute confrontés. La lecture de toutes les
références suggérées ici est vivement recommandée.
</p>
      <p>
Vous pouvez avoir besoin d’éditer vous-mêmes les fichiers de modèle
d’empaquetage produits par la commande <span class="command"><strong>dh_make</strong></span> pour
répondre à des préoccupations de ce chapitre. La nouvelle commande
<span class="command"><strong>debmake</strong></span> devrait le faire de meilleure façon.
</p>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="library"/>A.1. Bibliothèques partagées</h2>
            </div>
          </div>
        </div>
        <p>
Avant d'empaqueter des <a class="ulink" href="http://fr.wikipedia.org/wiki/Bibliothèque_logicielle">bibliothèques</a>
partagées, vous devriez lire les références essentielles suivantes avec
attention :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-sharedlibs.html">Charte Debian, 8 « Bibliothèques
partagées »</a> ;
</p>
            </li>
            <li class="listitem">
              <p>
<a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-opersys.html#s-fhs">Charte Debian, 9.1.1 « Structure de système de
fichiers »</a> ;
</p>
            </li>
            <li class="listitem">
              <p>
<a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-files.html#s-libraries">Charte Debian, 10.2
« Bibliothèques »</a>.
</p>
            </li>
          </ul>
        </div>
        <p>
Voici quelques conseils simplifiés à l'extrême pour commencer :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
les bibliothèques partagées sont des fichiers objet <a class="ulink" href="http://fr.wikipedia.org/wiki/Executable_and_Linkable_Format">ELF</a> contenant du code compilé ;
</p>
            </li>
            <li class="listitem">
              <p>
les bibliothèques partagées sont distribuées en fichiers
<code class="filename">*.so</code> (pas en fichiers <code class="filename">*.a</code> ni en
fichiers <code class="filename">*.la</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
les bibliothèques partagées sont surtout utilisées pour partager du code
commun à plusieurs exécutables avec le mécanisme <span class="command"><strong>ld</strong></span> ;
</p>
            </li>
            <li class="listitem">
              <p>
les bibliothèques partagées sont parfois utilisées pour fournir plusieurs
greffons à un exécutable avec le mécanisme <span class="command"><strong>dlopen</strong></span> ;
</p>
            </li>
            <li class="listitem">
              <p>
les bibliothèques partagées exportent des <a class="ulink" href="http://en.wikipedia.org/wiki/Symbol_(programming)">symboles</a> qui représentent des objets compilés comme
des variables, des fonctions et des classes ; elles permettent qu’on y
accède à partir des exécutables liés ; 
</p>
            </li>
            <li class="listitem">
              <p>
le <a class="ulink" href="http://en.wikipedia.org/wiki/Soname">SONAME</a> d'une bibliothèque partagée
<code class="filename">lib<em class="replaceable"><code>truc</code></em>.so</code>.<em class="replaceable"><code>1</code></em> :
<code class="literal">objdump -p
lib<em class="replaceable"><code>truc</code></em>.so.<em class="replaceable"><code>1</code></em> | grep
SONAME</code> ;<a href="#ftn.idp40126592" class="footnote" id="idp40126592"><sup class="footnote">[89]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
le SONAME d'une bibliothèque partagée correspond normalement au nom du
fichier de bibliothèque (mais pas toujours) ;
</p>
            </li>
            <li class="listitem">
              <p>
le SONAME d'une bibliothèque partagée liée à
<code class="filename"><em class="replaceable"><code>/usr/bin/truc</code></em></code> :
<code class="literal">objdump -p <em class="replaceable"><code>/usr/bin/truc</code></em> | grep
NEEDED</code> ;<a href="#ftn.idp40132064" class="footnote" id="idp40132064"><sup class="footnote">[90]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
<code class="systemitem">lib<em class="replaceable"><code>truc</code></em><em class="replaceable"><code>1</code></em></code> :
le paquet de bibliothèque pour la bibliothèque partagée
<code class="filename">lib<em class="replaceable"><code>truc</code></em>.so.<em class="replaceable"><code>1</code></em></code>
avec la version d'ABI SONAME <em class="replaceable"><code>1</code></em> ;<a href="#ftn.idp40137648" class="footnote" id="idp40137648"><sup class="footnote">[91]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
les scripts du responsable du paquet de bibliothèque doivent appeler
<span class="command"><strong>ldconfig</strong></span> dans des circonstances particulières pour créer
les liens symboliques nécessaires au SONAME ;<a href="#ftn.idp40140752" class="footnote" id="idp40140752"><sup class="footnote">[92]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
<code class="systemitem">lib<em class="replaceable"><code>truc</code></em><em class="replaceable"><code>1</code></em>-dbg</code> :
le paquet de symboles de débogage qui contient les symboles de débogage du
paquet de bibliothèque partagée <code class="systemitem">lib<em class="replaceable"><code>truc</code></em><em class="replaceable"><code>1</code></em></code> ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="systemitem">lib<em class="replaceable"><code>truc</code></em>-dev</code> : le
paquet de développement qui contient les fichiers d'en-têtes, etc. de la
bibliothèque partagée
<code class="filename">lib<em class="replaceable"><code>truc</code></em>.so.<em class="replaceable"><code>1</code></em></code> ;<a href="#ftn.idp40148592" class="footnote" id="idp40148592"><sup class="footnote">[93]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
les paquets Debian ne devraient normalement pas contenir de fichiers
d'archive Libtool <code class="filename">*.la</code> ;<a href="#ftn.idp40152192" class="footnote" id="idp40152192"><sup class="footnote">[94]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
les paquets Debian ne devraient normalement pas utiliser RPATH ;<a href="#ftn.idp40154912" class="footnote" id="idp40154912"><sup class="footnote">[95]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
bien qu'il soit dépassé et que ce ne soit qu'une référence secondaire, le
<a class="ulink" href="http://www.netfort.gr.jp/~dancer/column/libpkg-guide/libpkg-guide.html">guide d'empaquetage de
bibliothèques Debian</a> peut encore être utile.
</p>
            </li>
          </ul>
        </div>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="librarysymbols"/>A.2. Gestion de
<code class="filename">debian/<em class="replaceable"><code>paquet</code></em>.symbols</code></h2>
            </div>
          </div>
        </div>
        <p>
Lors de l'empaquetage d'une bibliothèque partagée, il faut créer un fichier
<code class="filename">debian/<em class="replaceable"><code>paquet</code></em>.symbols</code> pour
gérer la version minimale associée à chaque symbole pour les modifications
d'ABI rétrocompatibles sous le même SONAME de la bibliothèque pour le même
nom de paquet de bibliothèque partagée.<a href="#ftn.idp40162016" class="footnote" id="idp40162016"><sup class="footnote">[96]</sup></a>
Vous devriez lire les références essentielles suivantes avec attention :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-sharedlibs-symbols">Charte Debian, 8.6.3 « Le système de
symboles »</a> ;<a href="#ftn.idp40164960" class="footnote" id="idp40164960"><sup class="footnote">[97]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
<span class="citerefentry"><span class="refentrytitle">dh_makeshlibs</span>(1)</span> ;
</p>
            </li>
            <li class="listitem">
              <p>
<span class="citerefentry"><span class="refentrytitle">dpkg-gensymbols</span>(1)</span> ;
</p>
            </li>
            <li class="listitem">
              <p>
<span class="citerefentry"><span class="refentrytitle">dpkg-shlibdeps</span>(1)</span> ;
</p>
            </li>
            <li class="listitem">
              <p>
<span class="citerefentry"><span class="refentrytitle">deb-symbols</span>(5)</span>.
</p>
            </li>
          </ul>
        </div>
        <p>
Voici un exemple grossier de création du paquet <code class="systemitem">libtruc1</code> à la version amont
<code class="literal">1.3</code> avec le fichier
<code class="filename">debian/libtruc1.symbols</code> adéquat :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
préparer le squelette d'arborescence source Debian en utilisant le fichier
amont <code class="filename">libtruc-1.3.tar.gz</code> :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>
s'il s'agit du premier empaquetage du paquet <code class="systemitem">libtruc1</code>, créer le fichier vide
<code class="filename">debian/libtruc1.symbols</code> ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
si la version amont précédente <code class="literal">1.2</code> a été empaquetée en
tant que paquet <code class="systemitem">libtruc1</code> contenant
le fichier <code class="filename">debian/libtruc1.symbols</code> adéquat dans son
paquet source, le réutiliser ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
si la version amont précédente <code class="literal">1.2</code> n'a pas été empaquetée
avec le fichier <code class="filename">debian/libtruc1.symbols</code> adéquat, le
créer comme fichier <code class="filename">symbols</code> à partir de tous les
paquets binaires disponibles de même nom de paquet de bibliothèque partagée
contenant le même SONAME de la bibliothèque, par exemple de versions
<code class="literal">1.1-1</code> et <code class="literal">1.2-1</code> :<a href="#ftn.idp40186544" class="footnote" id="idp40186544"><sup class="footnote">[98]</sup></a>
</p>
                    <pre class="screen">
$ dpkg-deb -x libtruc1_1.1-1.deb libtruc1_1.1-1
$ dpkg-deb -x libtruc1_1.2-1.deb libtruc1_1.2-1
$ : &gt; symbols
$ dpkg-gensymbols -v1.1 -plibtruc1 -Plibtruc1_1.1-1 -Osymbols
$ dpkg-gensymbols -v1.2 -plibtruc1 -Plibtruc1_1.2-1 -Osymbols
</pre>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>
essayer de construire depuis l'arborescence source avec des outils comme
<span class="command"><strong>debuild</strong></span> et <span class="command"><strong>pdebuild</strong></span> (en cas d'échecs
dus à des symboles manquants, etc., c'est qu'il y a eu des modifications
d'ABI non rétrocompatibles qui nécessitent de changer le nom de paquet de
bibliothèque partagée en quelque chose comme <code class="systemitem">libtruc1a</code> avant de recommencer) :
</p>
              <pre class="screen">
$ cd libtruc-1.3
$ debuild
...
dpkg-gensymbols: warning: some new symbols appeared in the symbols file: ...
 see diff output below
--- debian/libtruc1.symbols (libtruc1_1.3-1_amd64)
+++ dpkg-gensymbolsFE5gzx        2012-11-11 02:24:53.609667389 +0900
@@ -127,6 +127,7 @@
  truc_get_name@Base 1.1
  truc_get_longname@Base 1.2
  truc_get_type@Base 1.1
+ truc_get_longtype@Base 1.3-1
  truc_get_symbol@Base 1.1
  truc_get_rank@Base 1.1
  truc_new@Base 1.1
...
</pre>
            </li>
            <li class="listitem">
              <p>
si un différentiel est affiché par <span class="command"><strong>dpkg-gensymbols</strong></span> comme
ci-dessus, extraire le fichier <code class="filename">symbols</code> du paquet
binaire généré de la bibliothèque partagée :<a href="#ftn.idp40197568" class="footnote" id="idp40197568"><sup class="footnote">[99]</sup></a>
</p>
              <pre class="screen">
$ cd ..
$ dpkg-deb -R  libtruc1_1.3_amd64.deb libtruc1-tmp
$ sed -e 's/1\.3-1/1\.3/' libtruc1-tmp/DEBIAN/symbols \
        &gt;libtruc-1.3/debian/libtruc1.symbols
</pre>
            </li>
            <li class="listitem">
              <p>
construire les paquets pour la publication avec des outils comme
<span class="command"><strong>debuild</strong></span> et <span class="command"><strong>pdebuild</strong></span> :
</p>
              <pre class="screen">
$ cd libtruc-1.3
$ debuild clean
$ debuild
...
</pre>
            </li>
          </ul>
        </div>
        <p>
En plus des exemples précédents, il faut vérifier plus profondément la
compatibilité d'ABI et changer vous-même les versions de certains symboles
si nécessaire. <a href="#ftn.idp40203984" class="footnote" id="idp40203984"><sup class="footnote">[100]</sup></a>
</p>
        <p>
Bien que ce ne soit qu'une référence secondaire, le <a class="ulink" href="http://wiki.debian.org/UsingSymbolsFiles">wiki Debian sur l'utilisation de fichiers
symboles</a> et les pages web qui y sont liées peuvent être utiles.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="multiarch"/>A.3. Multiarchitecture</h2>
            </div>
          </div>
        </div>
        <p>
La fonctionnalité de multiarchitecture introduite dans Debian Wheezy intègre
la prise en charge pour l'installation interarchitecture de paquets binaires
(en particulier entre <code class="literal">i386</code> et <code class="literal">amd64</code>,
mais aussi d'autres combinaisons) dans <code class="systemitem">dpkg</code> et <code class="systemitem">apt</code>. Vous devriez lire les références suivantes
avec attention :</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<a class="ulink" href="https://wiki.ubuntu.com/MultiarchSpec">wiki Ubuntu sur la spécification
multiarchitecture</a> (amont) ;
</p>
            </li>
            <li class="listitem">
              <p>
<a class="ulink" href="http://wiki.debian.org/Multiarch/Implementation">wiki Debian sur le multiarchitecture
et son implémentation</a> (situation dans Debian).
</p>
            </li>
          </ul>
        </div>
        <p>
Cela utilise le triplet du style <code class="literal">i386-linux-gnu</code> et
<code class="literal">x86_64-linux-gnu</code> pour le chemin d'installation des
bibliothèques partagées. Le chemin de triplet réel est défini dynamiquement
dans la variable <code class="literal">$(DEB_HOST_MULTIARCH)</code> par la commande
<span class="citerefentry"><span class="refentrytitle">dpkg-architecture</span>(1)</span>
pour chaque construction de paquet binaire. Par exemple, le chemin
d'installation de bibliothèques multiarchitectures est modifié comme
suit :<a href="#ftn.idp40218224" class="footnote" id="idp40218224"><sup class="footnote">[101]</sup></a>
</p>
        <div class="informaltable">
          <a id="tripletpaths"/>
          <table border="1">
            <colgroup>
              <col style="text-align: left"/>
              <col style="text-align: left"/>
              <col style="text-align: left"/>
            </colgroup>
            <thead>
              <tr>
                <th style="text-align: left">Ancien chemin</th>
                <th style="text-align: left">Chemin multiarchitecture i386</th>
                <th style="text-align: left">Chemin multiarchitecture amd64</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td style="text-align: left">
                  <code class="filename">/lib/</code>
                </td>
                <td style="text-align: left">
                  <code class="filename">/lib/i386-linux-gnu/</code>
                </td>
                <td style="text-align: left">
                  <code class="filename">/lib/x86_64-linux-gnu/</code>
                </td>
              </tr>
              <tr>
                <td style="text-align: left">
                  <code class="filename">/usr/lib/</code>
                </td>
                <td style="text-align: left">
                  <code class="filename">/usr/lib/i386-linux-gnu/</code>
                </td>
                <td style="text-align: left">
                  <code class="filename">/usr/lib/x86_64-linux-gnu/</code>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
        <p>
Voici quelques exemples typiques de scénarios de découpage de paquet
multiarchitecture pour les paquets suivants :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
une bibliothèque source
<code class="filename">lib<em class="replaceable"><code>truc</code></em>-1.tar.gz</code> ;
</p>
            </li>
            <li class="listitem">
              <p>
un outil source
<code class="filename"><em class="replaceable"><code>bidule</code></em>-1.tar.gz</code> écrit en
langage compilé ;
</p>
            </li>
            <li class="listitem">
              <p>
un outil source
<code class="filename"><em class="replaceable"><code>machin</code></em>-tar.gz</code> écrit en
langage interprété :
</p>
            </li>
          </ul>
        </div>
        <div class="informaltable">
          <a id="multiarchtable"/>
          <table border="1">
            <colgroup>
              <col style="text-align: left"/>
              <col style="text-align: left"/>
              <col style="text-align: left"/>
              <col style="text-align: left"/>
            </colgroup>
            <thead>
              <tr>
                <th style="text-align: left">Paquet</th>
                <th style="text-align: left">Architecture</th>
                <th style="text-align: left">Multi-Arch</th>
                <th style="text-align: left">Contenu du paquet</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td style="text-align: left">
                  <code class="systemitem">lib<em class="replaceable"><code>truc</code></em><em class="replaceable"><code>1</code></em></code>
                </td>
                <td style="text-align: left">any</td>
                <td style="text-align: left">same</td>
                <td style="text-align: left">
la bibliothèque partagée, co-installable
</td>
              </tr>
              <tr>
                <td style="text-align: left">
                  <code class="systemitem">lib<em class="replaceable"><code>truc</code></em><em class="replaceable"><code>1</code></em>-dbg</code>
                </td>
                <td style="text-align: left">any</td>
                <td style="text-align: left">same</td>
                <td style="text-align: left">
les symboles de débogage de bibliothèque partagée, co-installable
</td>
              </tr>
              <tr>
                <td style="text-align: left">
                  <code class="systemitem">lib<em class="replaceable"><code>truc</code></em>-dev</code>
                </td>
                <td style="text-align: left">any</td>
                <td style="text-align: left">same</td>
                <td style="text-align: left">
les fichiers d'en-tête, etc. de bibliothèque partagée, co-installable
</td>
              </tr>
              <tr>
                <td style="text-align: left">
                  <code class="systemitem">lib<em class="replaceable"><code>truc</code></em>-tools</code>
                </td>
                <td style="text-align: left">any</td>
                <td style="text-align: left">foreign</td>
                <td style="text-align: left">
les programmes de prise en charge en cours d'exécution, non co-installable
</td>
              </tr>
              <tr>
                <td style="text-align: left">
                  <code class="systemitem">lib<em class="replaceable"><code>truc</code></em>-doc</code>
                </td>
                <td style="text-align: left">all</td>
                <td style="text-align: left">foreign</td>
                <td style="text-align: left">
les fichiers de documentation de bibliothèque partagée
</td>
              </tr>
              <tr>
                <td style="text-align: left">
                  <code class="systemitem">
                    <em class="replaceable">
                      <code>bidule</code>
                    </em>
                  </code>
                </td>
                <td style="text-align: left">any</td>
                <td style="text-align: left">foreign</td>
                <td style="text-align: left">
les fichiers du programme compilé, non co-installable
</td>
              </tr>
              <tr>
                <td style="text-align: left">
                  <code class="systemitem"><em class="replaceable"><code>bidule</code></em>-doc</code>
                </td>
                <td style="text-align: left">all</td>
                <td style="text-align: left">foreign</td>
                <td style="text-align: left">
les fichiers de documentation du programme
</td>
              </tr>
              <tr>
                <td style="text-align: left">
                  <code class="systemitem">
                    <em class="replaceable">
                      <code>machin</code>
                    </em>
                  </code>
                </td>
                <td style="text-align: left">all</td>
                <td style="text-align: left">foreign</td>
                <td style="text-align: left">
les fichiers du programme interprété
</td>
              </tr>
            </tbody>
          </table>
        </div>
        <p>
Veuillez remarquer que le paquet de développement devrait contenir un lien
symbolique vers la bibliothèque partagée associée <span class="strong"><strong>sans numéro de version</strong></span>. Par exemple :
<code class="filename">/usr/lib/x86_64-linux-gnu/libtruc.so</code> →
<code class="filename">libtruc.so.1</code>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="librarypackage"/>A.4. Construction d'un paquet de bibliothèque partagée</h2>
            </div>
          </div>
        </div>
        <p>
Un paquet de bibliothèque partagée peut être construit en activant la prise
en charge multiarchitecture en utilisant <span class="citerefentry"><span class="refentrytitle">dh</span>(1)</span>
comme ceci : 
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
mettre à jour <code class="filename">debian/control</code> :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>
ajouter <code class="literal">Build-Depends: debhelper (&gt;=9)</code> à la section du
paquet source ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
ajouter <code class="literal">Pre-Depends: ${misc:Pre-Depends}</code> pour chaque
paquet binaire de bibliothèque partagée ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
ajouter la définition <code class="literal">Multi-Arch:</code> à chaque section de
paquet binaire ;
</p>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>
définir <code class="filename">debian/compat</code> à « 9 » ;
</p>
            </li>
            <li class="listitem">
              <p>
ajuster le chemin classique <code class="literal">/usr/lib/</code> en
<code class="literal">/usr/lib/$(DEB_HOST_MULTIARCH)/</code> multiarchitecture pour
tous les scripts d'empaquetage :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>
appeler d'abord <code class="literal">DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture
-qDEB_HOST_MULTIARCH)</code> dans <code class="filename">debian/rules</code> pour
définir la variable <code class="literal">DEB_HOST_MULTIARCH</code> ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
remplacer <code class="literal">/usr/lib/</code> par
<code class="literal">/usr/lib/$(DEB_HOST_MULTIARCH)/</code> dans
<code class="filename">debian/rules</code> ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
si <code class="literal">./configure</code> est utilisé par la cible
<code class="literal">override_dh_auto_configure</code> dans
<code class="filename">debian/rules</code>, assurez-vous de le remplacer par
<code class="literal">dh_auto_configure --</code> ;<a href="#ftn.idp40290080" class="footnote" id="idp40290080"><sup class="footnote">[102]</sup></a>
</p>
                  </li>
                  <li class="listitem">
                    <p>
remplacer toutes les occurrences de <code class="literal">/usr/lib/</code> par
<code class="literal">/usr/lib/*/</code> dans les fichiers
<code class="filename">debian/<em class="replaceable"><code>truc</code></em>.install</code> ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
générer les fichiers comme
<code class="filename">debian/<em class="replaceable"><code>truc</code></em>.links</code> à partir
de <code class="filename">debian/<em class="replaceable"><code>truc</code></em>.links.in</code>
dynamiquement en ajoutant un script à la cible
<code class="literal">override_dh_auto_configure</code> dans
<code class="filename">debian/rules</code> :
</p>
                    <pre class="screen">
override_dh_auto_configure:
        dh_auto_configure
        sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
                debian/<em class="replaceable"><code>truc</code></em>.links.in &gt; debian/<em class="replaceable"><code>truc</code></em>.links
</pre>
                  </li>
                </ul>
              </div>
            </li>
          </ul>
        </div>
        <p>
Veuillez vous assurer d'avoir vérifié que le paquet de bibliothèque partagée
ne contient que les fichiers attendus, et que le paquet -dev fonctionne
toujours.
</p>
        <p>
Tous les fichiers installés simultanément par des paquets multiarchitectures
au même endroit devraient avoir exactement le même contenu. Vous devez faire
attention aux différences générées par l'ordre des octets de données
(boutisme) et par les algorithmes de compression.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="native-dh-make"/>A.5. Paquet Debian natif</h2>
            </div>
          </div>
        </div>
        <p>
Si un paquet est maintenu uniquement pour Debian ou simplement pour un usage
local, ses sources peuvent contenir tous les fichiers
<code class="filename">debian/*</code>. Il existe deux façons de l’empaqueter.
</p>
        <p>
Vous pouvez créer l’archive amont en excluant les fichiers
<code class="filename">debian/*</code> et l’empaqueter comme un paquet Debian non
natif comme dans <a class="xref" href="first.fr.html#workflow" title="2.1. Processus de construction de paquet Debian">Section 2.1, « Processus de construction de paquet Debian »</a>. C’est la méthode normale que
certaines personnes préconisent d’utiliser.
</p>
        <p>
L’autre méthode est d’utiliser la manière de procéder pour un paquet Debian
natif.
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
créer le paquet source Debian natif au format <code class="literal">3.0
(native)</code> en utilisant un seul fichier tar compressé où tous les
fichiers sont intégrés :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <code class="literal"><em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>.tar.gz</code>
                  </li>
                  <li class="listitem">
                    <code class="literal"><em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>.dsc</code>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>
construire les paquets binaires Debian à partir du paquet source Debian
natif :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <code class="literal"><em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>_<em class="replaceable"><code>arch</code></em>.deb</code>
                  </li>
                </ul>
              </div>
            </li>
          </ul>
        </div>
        <p>
Par exemple, si vous avez des fichiers source dans
<code class="filename">~/mypackage-1.0</code> sans les fichiers
<code class="filename">debian/*</code>, vous pouvez créer un paquet natif Debian pour
eux en utilisant la commande <span class="command"><strong>dh_make</strong></span> comme suit :
</p>
        <pre class="screen">
$ cd ~/monpaquet-1.0
$ dh_make --native
</pre>
        <p>
Alors le répertoire <code class="filename">debian</code> et son contenu sont créés
comme en <a class="xref" href="first.fr.html#non-native-dh-make" title="2.8. Paquet Debian non natif initial">Section 2.8, « Paquet Debian non natif initial »</a>. Aucune archive compressée
n'est créée puisqu'il s'agit d'un paquet Debian natif, mais c'est la seule
différence. La suite de l'empaquetage est à peu près similaire.
</p>
        <p>
Après exécution de la commande <span class="command"><strong>dpkg-buildpackage</strong></span>, les
fichiers suivants apparaîtront dans le répertoire parent :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<code class="filename">monpaquet_1.0.tar.gz</code>
</p>
              <p>
c'est l'archive compressée du code source créé à partir du répertoire
<code class="filename">monpaquet-1.0</code> par la commande
<span class="command"><strong>dpkg-source</strong></span> (il ne se termine pas par
<code class="filename">orig.tar.gz</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename">monpaquet_1.0.dsc</code>
</p>
              <p>
c'est un résumé du contenu du code source comme dans un paquet Debian non
natif (il n'y a pas de révision Debian) ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename">monpaquet_1.0_i386.deb</code>
</p>
              <p>
c'est le paquet binaire terminé comme dans un paquet Debian non natif (il
n'y a pas de révision Debian) ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename">monpaquet_1.0_i386.changes</code>
</p>
              <p>
ce fichier décrit toutes les modifications effectuées dans la version
actuelle du paquet comme dans un paquet Debian non natif (il n'y a pas de
révision Debian).
</p>
            </li>
          </ul>
        </div>
      </div>
      <div class="footnotes">
        <br/>
        <hr/>
        <div id="ftn.idp40126592" class="footnote">
          <p><a href="#idp40126592" class="para"><sup class="para">[89] </sup></a>
Alternative : <code class="literal">readelf -d
lib<em class="replaceable"><code>truc</code></em>.so.<em class="replaceable"><code>1</code></em> | grep
SONAME</code>.
</p>
        </div>
        <div id="ftn.idp40132064" class="footnote">
          <p><a href="#idp40132064" class="para"><sup class="para">[90] </sup></a>
Alternative : <code class="literal">readelf -d
lib<em class="replaceable"><code>truc</code></em>.so.<em class="replaceable"><code>1</code></em> | grep
NEEDED</code>.
</p>
        </div>
        <div id="ftn.idp40137648" class="footnote">
          <p><a href="#idp40137648" class="para"><sup class="para">[91] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-sharedlibs-runtime">Charte
Debian, 8.1 « Bibliothèques partagées au moment de l'exécution »</a>.</p>
        </div>
        <div id="ftn.idp40140752" class="footnote">
          <p><a href="#idp40140752" class="para"><sup class="para">[92] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-ldconfig">Charte Debian,
8.1.1 « ldconfig »</a>.</p>
        </div>
        <div id="ftn.idp40148592" class="footnote">
          <p><a href="#idp40148592" class="para"><sup class="para">[93] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-sharedlibs-static">Charte Debian, 8.3 « Bibliothèques
statiques »</a> et la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-sharedlibs-dev">Charte Debian,
8.4 « Fichiers de développement »</a>.</p>
        </div>
        <div id="ftn.idp40152192" class="footnote">
          <p><a href="#idp40152192" class="para"><sup class="para">[94] </sup></a>Consultez le <a class="ulink" href="http://wiki.debian.org/ReleaseGoals/LAFileRemoval">wiki Debian sur l'objectif de
publication relatif à la suppression des fichiers
<code class="filename">*.la</code></a>.</p>
        </div>
        <div id="ftn.idp40154912" class="footnote">
          <p><a href="#idp40154912" class="para"><sup class="para">[95] </sup></a>Consultez le <a class="ulink" href="http://wiki.debian.org/RpathIssue">wiki Debian sur les problèmes avec
RPATH<code class="filename">*.la</code></a>.</p>
        </div>
        <div id="ftn.idp40162016" class="footnote">
          <p><a href="#idp40162016" class="para"><sup class="para">[96] </sup></a>Les modifications d'ABI non rétrocompatibles devraient normalement
nécessiter une mise à jour du SONAME de la bibliothèque et du nom de paquet
de la bibliothèque partagée.</p>
        </div>
        <div id="ftn.idp40164960" class="footnote">
          <p><a href="#idp40164960" class="para"><sup class="para">[97] </sup></a>Pour les bibliothèques C++ et d'autres cas lorsque le suivi de symboles
individuels est trop compliqué, suivez plutôt la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-sharedlibs-shlibdeps">Charte Debian, 8.6.4 « Le système de
shlibs »</a>.</p>
        </div>
        <div id="ftn.idp40186544" class="footnote">
          <p><a href="#idp40186544" class="para"><sup class="para">[98] </sup></a>
Toutes les versions précédentes des paquets Debian sont disponibles sur
<a class="ulink" href="http://snapshot.debian.org/">http://snapshot.debian.org/</a>. La révision
Debian est supprimée de la version pour faciliter le rétroportage du
paquet : <code class="literal">1.1</code> &lt;&lt; <code class="literal">1.1-1~bpo70+1</code>
&lt;&lt; <code class="literal">1.1-1</code> et <code class="literal">1.2</code> &lt;&lt;
<code class="literal">1.2-1~bpo70+1</code> &lt;&lt; <code class="literal">1.2-1</code>
</p>
        </div>
        <div id="ftn.idp40197568" class="footnote">
          <p><a href="#idp40197568" class="para"><sup class="para">[99] </sup></a>
La révision Debian est supprimée de la version pour faciliter le
rétroportage du paquet : <code class="literal">1.1</code> &lt;&lt;
<code class="literal">1.3</code> &lt;&lt; <code class="literal">1.3-1~bpo70+1</code> &lt;&lt;
<code class="literal">1.3-1</code>
</p>
        </div>
        <div id="ftn.idp40203984" class="footnote">
          <p><a href="#idp40203984" class="para"><sup class="para">[100] </sup></a>
Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-sharedlibs.html#s-sharedlibs-updates">Charte
Debian, 8.6.2 « Modifications d'ABI dans les bibliothèques
partagées »</a>.
</p>
        </div>
        <div id="ftn.idp40218224" class="footnote">
          <p><a href="#idp40218224" class="para"><sup class="para">[101] </sup></a>Certains anciens chemins de bibliothèques particulières comme
<code class="filename">/lib32/</code> et <code class="filename">/lib64/</code> ne sont plus
utilisés.</p>
        </div>
        <div id="ftn.idp40290080" class="footnote">
          <p><a href="#idp40290080" class="para"><sup class="para">[102] </sup></a>
Sinon, les arguments
<code class="literal">--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)</code> et
<code class="literal">--libexecdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)</code>
peuvent être ajoutés à <code class="literal">./configure</code>. Veuillez remarquer
que <code class="literal">--libexecdir</code> indique le chemin par défaut pour
installer les programmes exécutables démarrés par d'autres programmes plutôt
que par des utilisateurs. Sa valeur Autotools par défaut est
<code class="filename">/usr/libexec/</code> mais sa valeur Debian par défaut est
<code class="filename">/usr/lib/</code>.
</p>
        </div>
      </div>
    </div>
    <div class="navfooter">
      <hr/>
      <table width="100%" summary="Navigation footer">
        <tr>
          <td align="left"><a accesskey="p" href="upload.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <td align="center"> </td>
          <td align="right"> </td>
        </tr>
        <tr>
          <td align="left" valign="top">Chapitre 9. Envoi de paquet </td>
          <td align="center">
            <a accesskey="h" href="index.fr.html">
              <img src="images/home.png" alt="Sommaire"/>
            </a>
          </td>
          <td align="right" valign="top"> </td>
        </tr>
      </table>
    </div>
  </body>
</html>
